import React from 'react'
import { debounce, isEqual } from './helpers'

export default class Scrollable extends React.Component {
  componentWillReceiveProps = n => {
    if (n.scrollTop !== this.props.scrollTop) {
      this.e.scrollTop = n.scrollTop
    }
    if (n.disable !== this.props.disable) {
      if (n.disable) this.e.style.pointerEvents = 'none'
      else this.e.style.pointerEvents = 'auto'
    }
  }

  shouldComponentUpdate = (next) => {
    return !isEqual(next.children.props, this.props.children.props)
  }

  debouncedScroll = debounce(() => this.props.onScroll(this.e.scrollTop))

  handleScroll = (e) => {
    if (this.props.customOnScroll) {
      this.props.customOnScroll(e)
    }
    this.debouncedScroll()
  }

  render() {
    const { children, height, ...rest } = this.props
    return (
      <div
        {...rest}
        style={{
          height: height || '100%',
          overflow: 'scroll',
          position: 'relative',
        }}
        ref={e => this.e = e}
        onScroll={this.handleScroll}
      >
        {children}
      </div>
    )
  }
}
